// CRC8   ,  
// Proteus
// icq: 133575351  email:lawnmower-man@mail.ru 

#include<stdio.h>
#include<string.h>

typedef unsigned char  byte;

//  

#define POLYNOM8_1			0xD5
#define POLYNOM8_2			0xAB
#define POLYNOM8_3			0x57
#define POLYNOM8_ATM1		0x07	//(use: ATM HEC)	
#define POLYNOM8_ATM2		0xE0	
#define POLYNOM8_ATM3		0xC1
#define POLYNOM8_CCITT1		0x8D	//(use: 1-Wire bus)
#define POLYNOM8_CCITT2		0xB1
#define POLYNOM8_CCITT3		0x63
#define POLYNOM8_DALLAS1	0x31	//(use: 1-Wire bus)
#define POLYNOM8_DALLAS2	0x8C
#define POLYNOM8_DALLAS3	0x19
#define POLYNOM8_SAE1		0x1D
#define POLYNOM8_SAE2		0xB8




//!     
class CRC8 {
	byte crc8_table[256];
public:
	CRC8(byte polynom);
	byte Calc(byte*,int count);
};


CRC8::CRC8(byte polynom)
{
	int n,k; byte c;
	for(n=0;n<256;n++) {
		c=n;
		for(k=0;k<8;k++) c=c>>1^(-(int)(c&1)&polynom);
		crc8_table[n]=c;
	}
}

byte CRC8::Calc(byte* data,int count)
{
	byte value=(byte)-1; 
	while(count--) value=crc8_table[(byte)value^*data++]; 
	return value; 
}

//     (    5 )
byte _crc8(byte *data,int count,byte polynom) 
{
	int n;
	byte sum=(byte)-1;
	while(count--) {
		sum^=*data++;
		for(n=0;n<8;n++) sum=(-(sum&1)&polynom)^(sum>>1);
	}
	return sum;
}



void main()
{
	byte data[]="3,1415926535897932384626433832795";
	if(sizeof(byte)!=1) printf("type error\n\a"),getchar();
	CRC8 crc(POLYNOM8_1); byte res1,res2;
	res1=crc.Calc(data,strlen((char*)data));
	res2=_crc8(data,strlen((char*)data),POLYNOM8_1);
	if(res1!=0x25 || res2!=0x25) printf("Internal error\n\a"),getchar();
	printf("node\n");
}